${eCAP_AV_SDK_BOILERPLATE}

#include "Adapter.h"

#include <cerrno>
#include <cstring>
#include <string>
#include <limits>

#include <libecap/common/errors.h>

#include "Time.h"


Time Time::Now()
{
    timeval now;
    if (gettimeofday(&now, 0) < 0) {
        const int errNo = errno; // save to avoid corrupting
        throw TextExceptionHere("${eCAP_AV_SDK_SHORT_NAME}: gettimeofday(2) failure: " + std::string(strerror(errNo)));
    }
    return Time(now);
}

Time Time::Max()
{
    return Time(std::numeric_limits<time_t>::max(), 999999L);
}

Time & Time::operator +=(const Time &tm)
{
    tv_sec += tm.tv_sec;
    tv_usec += tm.tv_usec;

    if (tv_usec >= 1000000L) {
        tv_usec -= 1000000L;
        ++tv_sec;
    }

    return *this;
}

Time & Time::operator -=(const Time &tm)
{
    tv_sec -= tm.tv_sec;
    tv_usec -= tm.tv_usec;

    if (tv_usec < 0) {
        tv_usec += 1000000L;
        --tv_sec;
    }

    return *this;
}
